using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using TIS.Imaging;

namespace VCD_Simple
{
    public partial class Form1 : Form
    {
        private VCDButtonProperty SoftwareTrigger;
        private VCDMapStringsProperty ExposureMode;
        private VCDAbsoluteValueProperty TriggerDelay;
        private VCDAbsoluteValueProperty TriggerDebounceTime;
        private VCDAbsoluteValueProperty TriggerMaskTime;
        private VCDAbsoluteValueProperty TriggerNoiseSuppressionTime;
        private VCDRangeProperty TriggerBurstCount;
        private VCDRangeProperty TriggerBurstInterval;
        private VCDMapStringsProperty TriggerOverlap;

        private int counter = 1;
        public Form1()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Form1_Load
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1_Load(object sender, EventArgs e)
        {

            if (icImagingControl1.DeviceValid == false)
            {
                icImagingControl1.ShowDeviceSettingsDialog();
            }



            if (icImagingControl1.DeviceValid)
            {

                SoftwareTrigger = icImagingControl1.VCDPropertyItems.Find<VCDButtonProperty>(VCDGUIDs.VCDID_TriggerMode,
                                                    VCDGUIDs.VCDElement_SoftwareTrigger);//錾

                ExposureMode = icImagingControl1.VCDPropertyItems.Find<VCDMapStringsProperty>(VCDGUIDs.VCDID_TriggerMode,
                                                VCDGUIDs.VCDElement_Trigger_ExposureMode);//

                //gK[Delay錾
                TriggerDelay = icImagingControl1.VCDPropertyItems.Find<VCDAbsoluteValueProperty>(VCDGUIDs.VCDID_TriggerMode,
                                                VCDGUIDs.VCDElement_TriggerDelay);

                //DebounceTime錾;
                TriggerDebounceTime = icImagingControl1.VCDPropertyItems.Find<VCDAbsoluteValueProperty>(VCDGUIDs.VCDID_TriggerMode,
                                                VCDGUIDs.VCDElement_TriggerDebounceTime);

                //MaskTime錾
                TriggerMaskTime = icImagingControl1.VCDPropertyItems.Find<VCDAbsoluteValueProperty>(VCDGUIDs.VCDID_TriggerMode,
                                                VCDGUIDs.VCDElement_TriggerMaskTime);

                //NoiseSuppressionTime錾
                TriggerNoiseSuppressionTime = icImagingControl1.VCDPropertyItems.Find<VCDAbsoluteValueProperty>(VCDGUIDs.VCDID_TriggerMode,
                                                VCDGUIDs.VCDElement_TriggerNoiseSuppressionTime);//gK[Delay錾;

                //BurstCount錾;
                TriggerBurstCount = icImagingControl1.VCDPropertyItems.Find<VCDRangeProperty>(VCDGUIDs.VCDID_TriggerMode,
                                                VCDGUIDs.VCDElement_Trigger_BurstCount);

                //BurstInterval錾;
                TriggerBurstInterval = icImagingControl1.VCDPropertyItems.Find<VCDRangeProperty>(VCDGUIDs.VCDID_TriggerMode,
                                                 Guid.Parse("A9715AB3-69AE-454D-8DF5-7E06D87C109C"));


                //gK[Overlap錾
                TriggerOverlap = icImagingControl1.VCDPropertyItems.Find<VCDMapStringsProperty>(VCDGUIDs.VCDID_TriggerMode,
                                                Guid.Parse("7685BF04-C9C9-4AE2-BA69-1278B77F97F6"));



                icImagingControl1.LiveDisplayDefault = false;
                icImagingControl1.DeviceTrigger = true; //gK[[hI
               
                icImagingControl1.LiveCaptureLastImage = false; // Do not save an image on live stop.
                icImagingControl1.LiveDisplay = false; //Cu摜\Ȃ
                icImagingControl1.Sink = new FrameQueueSink(ShowBuffer, MediaSubtypes.RGB32, 5);


                icImagingControl1.LiveStart();//CuX^[g
                    
   
            }
        }

        private FrameQueuedResult ShowBuffer(IFrameQueueBuffer buffer)
        {

            icImagingControl1.DisplayImageBuffer(buffer);

            //obt@̓eJPEGt@CƂăfBXNɕۑ܂B
            string filename = String.Format("test{0}.jpg", counter);
            buffer.SaveAsJpeg(filename, 70);
            counter++;
            return FrameQueuedResult.ReQueue;
        }
        //private void IcImagingControl1_ImageAvailable(object sender, ICImagingControl.ImageAvailableEventArgs e)
        //{

        //    ImageBuffer CurrentBuffer = null;
        //    CurrentBuffer = icImagingControl1.ImageBuffers[e.bufferIndex];@//Cu摜\
        //    icImagingControl1.DisplayImageBuffer(CurrentBuffer);@//Cu摜\

        //    //obt@̓eJPEGt@CƂăfBXNɕۑ܂B
        //    string filename = String.Format("test{0}.jpg", counter);
        //    CurrentBuffer.SaveAsJpeg(filename, 70);
        //    counter++;
            
        //}


        /// <summary>
        /// Button1_Click
        /// \tggK[
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Button1_Click(object sender, EventArgs e)
        {
            SoftwareTrigger.Push(); //\tgEFAgK[   
            
        }

    }
}